image: node:12.16.1

cache:
    paths:
        - node_modules/
        - .yarn

stages:
    - install
    - lint
    - test
    - build
    - deploy

install:
    stage: install
    script:
        - yarn install --production=false
        - echo "Install"

lint:
    stage: lint
    script:
        - yarn lint
        - echo "ESLint"

build:
    stage: build
    script:
        - yarn build
        - echo "Build"

test:
    stage: test
    script:
        - yarn test
        - echo "Test"

deploy-prod:
    stage: deploy
    only:
        - master
    script:
        - yarn
        - yarn run build
        - yarn firebase-use
        - yarn firebase-deploy